this.name        = "oolite-nova"; 
this.author      = "eric walch"; 
this.copyright   = " 2008 the Oolite team."; 
this.description = ""; 
this.version     = "1.71"; 

this.DISABLE=function(name)
{
    if (!this.old) this.old={};
    if (!name || name=='') return;
    if (!this.old[name])
            this.old[name]=this[name];
    //this[name]=function(){};
    delete this[name];
}

this.ENABLE=function(name)
{
    if (!name || name==''||!this.old) return;
    this[name]=this.old[name];
}
this.CLEANUP = function()
{ //can't check missionVariables inside startUp or reset
    if (missionVariables.nova == "NOVA_HERO")
    {
        LogWithClass('script.Nova.cleanup', 'Nova finished. Disabling script.');
        //no need to run any of these!
        this.DISABLE("shipDockedWithStation");	
        this.DISABLE("shipLaunchedEscapePod");
        this.DISABLE("shipWillExitWitchspace");
        this.DISABLE("missionScreenEnded");
        this.DISABLE("missionChoiceWasReset");
    } 
    else
    {
        if (this.old)
        {
            this.ENABLE("shipDockedWithStation");	
            this.ENABLE("shipLaunchedEscapePod");
            this.ENABLE("shipWillExitWitchspace");
            this.ENABLE("missionScreenEnded");		
            this.ENABLE("missionChoiceWasReset");		
            LogWithClass('script.Nova.cleanup', 'Nova script disabled previously. Re-enabling script.');
        }
    }
    this.cleanup=function(){}; // run just once per script startup/reset
}

this.missionScreen=function(messageKey, backGround, choiceKey, ShipKey, MusicKey)
{
    mission.showShipModel(ShipKey);mission.setMusic(MusicKey);
    mission.setBackgroundImage(backGround);
    mission.showMissionScreen();
    mission.addMessageTextKey(messageKey);
    if (choiceKey) mission.setChoicesKey(choiceKey);
    mission.setBackgroundImage(); mission.setMusic();
}

this.missionOffers = function()
{
    if (guiScreen == "GUI_SCREEN_MISSION" || (mission.choice && mission.choice != "")) return; 
    // there will be a "missionScreenEnded" or a "missionChoiceWasReset" in future to react uppon.
    if (player.dockedStation.isMainStation)
    {
        if(galaxyNumber == 3)
        {
            if(!missionVariables.nova && !missionVariables.novacount) missionVariables.novacount = 0
            if(missionVariables.nova == "TWO_HRS_TO_ZERO")
            {
                this.missionScreen("nova_1", "solar.png", "nova_yesno");
                this.novaOffer = "NOVA_CHOICE" // use a temporary variable for the offering.
                this.novaMissionTimer.stop()
            }
        }
        if(galaxyNumber == 3 || galaxyNumber == 4)
        {
            if(missionVariables.nova == "NOVA_ESCAPED_SYSTEM")
            {
                player.removeAllCargo()
                player.awardCargo("Gem-Stones", 100)
                this.missionScreen("nova_hero", "solar.png")
                missionVariables.nova = "NOVA_HERO"
                mission.setInstructionsKey()
            }
            if(missionVariables.nova == "NOVA_ESCAPE_POD")
            {
                player.removeAllCargo() // can only be done while docked.
                missionVariables.nova = "NOVA_HERO" // not a real hero but other scripts expect this missionend string.
                mission.setInstructionsKey()
            }
            if(missionVariables.nova == "NOVA_ESCAPE_COWARD")
            {
                missionVariables.nova = "NOVA_HERO" // not a real hero but other scripts expect this missionend string.
            }
        }
    }
}

this.choiceEvaluation = function()
{
    if(!this.novaOffer) return;
    if (this.novaOffer == "NOVA_CHOICE")
    {
        if(mission.choice == "YES")
        {
            mission.resetMissionChoice()
            this.novaOffer = null
            player.useSpecialCargo(expandDescription("[nova_refugees]"))
            mission.setInstructionsKey("nova_missiondesc") 
            missionVariables.nova = "NOVA_ESCAPE_HERO" 
            player.launch()
            player.call("blowUpStation")
            system.setSunNova(30)
            missionVariables.novacount = null
        }
        else
        {
            // mission.choice = "NO", or null when player launched without a choice.
            mission.resetMissionChoice()
            this.novaOffer = null
            missionVariables.nova = "NOVA_ESCAPE_COWARD"
            player.commsMessage(expandDescription("[nova_coward]"), 4.5)
            system.setSunNova(3)
            missionVariables.novacount = null
        }
    }
}

// general, used when player enters nova system after mission.
this.sendShipsAway = function()
{
    if(!system.goneNova) {this.novaTimer.stop(); return}
    system.sendAllShipsAway()
}

// special, used when player enters nova system during mission.
this.sendShipsAwayForMission = function()
{
    if(missionVariables.nova != "TWO_HRS_TO_ZERO") {this.novaMissionTimer.stop(); return}
    system.sendAllShipsAway()
}


// below are the 6 eventhandlers that are triggered by the system.
this.startUp = this.reset = function()
{
    this.cleanup=this.CLEANUP;
}

this.shipWillLaunchFromStation = function(station)
{
    this.cleanup();
}

this.shipLaunchedEscapePod = function()
{
    if(missionVariables.nova == "NOVA_ESCAPED_SYSTEM") missionVariables.nova = "NOVA_ESCAPE_POD"
}

this.shipDockedWithStation = function()
{
    this.missionOffers()
}

this.missionScreenEnded = this.missionChoiceWasReset = function()
{
    this.choiceEvaluation()
    if(player.docked) this.missionOffers()
}

this.shipWillExitWitchspace = function() // call this as soon as possible so other scripts can see it will go nova.
{
    if(galaxyNumber == 3)
    {
        if(missionVariables.novacount) missionVariables.novacount++
        if(player.hasEquipment("EQ_GAL_DRIVE") && missionVariables.novacount > 3 && !missionVariables.nova)
        {
            missionVariables.nova = "TWO_HRS_TO_ZERO"
            player.fuelLeakRate = 25
            system.setSunNova(7200)
            player.consoleMessage(expandDescription("[nova_fuelleak]"), 4.5)
            player.call("setPlanetinfo:", "market = none")
            player.call("setPlanetinfo:", "sun_gone_nova = YES")
            if(this.novaMissionTimer) this.novaMissionTimer.start()
            else this.novaMissionTimer = new Timer(this, this.sendShipsAwayForMission, 60, 30)
        }
    }
    if(missionVariables.nova == "NOVA_ESCAPE_HERO") missionVariables.nova = "NOVA_ESCAPED_SYSTEM"
}

this.shipExitedWitchspace = function()
{
    if(system.goneNova)
    {
        if(this.novaTimer) this.novaTimer.start()
        else this.novaTimer = new Timer(this, this.sendShipsAway, 1, 60)
    }
}